package session2.oop.exercises.library;

public class Library {

	Book[] books = new Book[5];
	
	void borrowTitle (String title){
		
		// another way of borrowing
		for (int i = 0; i < books.length; ++i){
			if (books[i].equals(title))
				books[i].borrowBook();
		}
	}
	
	public static void main(String[] args) {
		
		Library l = new Library();
		
		// populating library
		l.books[0] = new Book("Alice in Wonderland", "Lewis Carroll",3);
		l.books[1] = new Book("The Wind in the Willows", "Kenneth Grahame",1);
		l.books[2] = new Book("Treasure Island", "Robert Louis Stevenson",2);
		l.books[3] = new Book("Harry Potter", "J. K. Rowling",4);
		l.books[4] = new Book("War of the Worlds", "H.G. Wells",1);
	
		// try to borrow two copies of a book and then return one
		for (int book_i = 0; book_i < l.books.length; ++book_i){
			System.out.println("Trying to borrow 2 copies of: "+ l.books[book_i].title);
			l.books[book_i].borrowBook();
			l.books[book_i].borrowBook();
		}
		
		for (int book_i = 0; book_i < l.books.length; ++book_i){
			System.out.println("Trying to return 1 copy of: "+ l.books[book_i].title);
			l.books[book_i].returnBook();
		}

		// or can make a list of requests
		Book[] requests = new Book[12];
		requests[0] = requests[1] = requests[2] = l.books[0];
		requests[3] = requests[4] = requests[5] = l.books[1];
		requests[6] = requests[7] = requests[8] = l.books[2];
		requests[9] = requests[10] = requests[11] = l.books[3];

		System.out.println("----");
		for (int req_i = 0; req_i < requests.length; ++req_i){
			System.out.println("Trying to borrow a copy of: "+ requests[req_i].title );
			requests[req_i].borrowBook();
		}
		
		// or a request based on a title
		
		l.borrowTitle("Harry Potter");
		
	}

}
