package session2.oop.exercises.restaurant;

public class Menu {
	static Dish[] _dishes = new Dish[10]; // full menu shared between menus
	
	private Dish[] _order = new Dish[3]; // order
	
	public static void addDish(Dish dish){
		addDish(dish,_dishes);
	}
	public static void addDish(Dish dish, Dish[] dishes){
		
		int menuPos = dish.getID(); // the position will be the number of dishes we have already created
		if (menuPos < dishes.length){
			dishes[menuPos] = dish;
			System.out.println("Menu item " + menuPos + " is " + dish.getName());
		}else{
			System.out.println("menu position " + menuPos + " does not exist" );
		}
	}
	
	public void setOrder (String starterDishName, String mainDishName, String desertDishName){

		int starterPos, mainPos, desertPos; 
		starterPos = mainPos = desertPos =-1;

		for (int i = 0; i< _dishes.length; ++i){
			if (_dishes[i].equals(starterDishName)) starterPos = i;
			if (_dishes[i].equals(mainDishName)) desertPos = i;
			if (_dishes[i].equals(desertDishName)) desertPos = i;			
		}
		
		if( starterPos < 0 || mainPos < 0 || desertPos < 0){
			System.out.println("One of the menu positions does not exist");
		}else{
			setOrder (starterPos, mainPos, desertPos);
		}
	}
	
	public void setOrder (int starterPos, int mainPos, int desertPos){
		if (starterPos >=  _dishes.length || mainPos >= _dishes.length || desertPos >= _dishes.length){
			System.out.println("One of the menu positions does not exist");
		}else{
			_order[0] = _dishes[starterPos];
			_order[1] = _dishes[mainPos];
			_order[2] = _dishes[desertPos];
			
			for (int d = 0; d < _order.length; ++d){
				_order[d].order();
			}
			
			System.out.println("Meal costs " + getPrice() + "euros and has " + getCalories() + " calories");
		}
	}
	
	private double getPrice(){
		double price = 0.0;
		for (int d = 0; d < _order.length; ++d){
			price += _order[d].getPrice();
		}	
		return price;
	}

	private int getCalories(){
		int calories = 0;
		for (int d = 0; d < _order.length; ++d){
			calories += _order[d].getCalories();
		}	
		return calories;
	}
	
	public void reverseMenu(){
		Dish[] tmp = new Dish[10];
		
		for (int d=_dishes.length-1, rev_d = 0; d >= 0; --d, ++rev_d ){
			tmp[rev_d] = _dishes[d]; // alternatively tmp[_dishes.lenght-1 - d] = _dishes[d]
		}
		_dishes = tmp;
	}

}
